#include <Windows.h>
#pragma comment( lib, "Ws2_32.lib" )

class Socket
{
public:
	Socket(void);
	~Socket(void);


	static bool LoadWSA(WSADATA& ws);
	static bool UnLoadWSA();


	bool CreateSocket(void); // метод создания  сокета
	bool SendData(LPCSTR,const int &); // метод  передачи данных
	bool RecvData(LPSTR,const int &); // метод полученя данных
	bool SendDataAll(std::string&); // метод  передачи данных
	bool RecvDataAll(std::string&); // метод полученя данных
	bool CloseSocket(void); // метод закрытия сокета
	int GetError(void)const; // метод возврата кода ошибки
	int GetSendSize(void)const; //метод возврата количеств переданых байтов методом SendData
	int GetRecvSize(void)const;// метод возврата киличества принятых байтов методом RecvData
	int ShootDown( const int& ); // прервать соединение (0 - прервать чтение, 1 - прервать отправку, 2 - прервать все операции)
	int Select(const int&,const int&);

	//string SendRequest( Request& );

	//----------client------------------------//

	// Подключение к серверу
	bool Connect(	LPCSTR		= "127.0.0.1",	// IP/Name сервера
		const UINT&	= 33333 );		// Порт сервера

	bool Disconnect( void );

	// Метод установки/сохранения сокета и структуры сетевой информации
	void SaveSocketAndSockaddr( const SOCKET&,			// Сокет
		const sockaddr_in* );	// Структура sockaddr_in

	//----------client------------------------//

	//----------Server-----------------------//

	bool Bind( LPCSTR		= "127.0.0.1",	// По умолчанию IP локальный, для удобства тестирования
		const UINT& = 33333,		// По умолчанию порт 33333
		const int&	= SOMAXCONN );	// По умолчанию SOMAXCONN клиентов будет ожидать сервер


	bool Listen(void); // метод прослушивания подключения клиентов
	bool Accept(Socket &); // метод приёма поключения клиента

	//----------Server-----------------------//
	
private:
	
	SOCKET socket;
	struct sockaddr_in addr; //структура информации:ip, post, семейство протоколов
	int err; //код ошибки
	int size_send, size_recv;// количество переданных/принятых байт

};